#!/usr/bin/python

# ||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
# Copyright (C) 2017 Piotr Murawski
# Niniejszy program jest wolnym oprogramowaniem; mozesz go
# rozprowadzac dalej i/lub modyfikowac na warunkach Powszechnej
# Licencji Publicznej GNU, wydanej przez Fundacje Wolnego
# Oprogramowania - wedlug wersji 3-ciej tej Licencji lub ktorejs
# z pozniejszych wersji.
# Niniejszy program rozpowszechniany jest z nadzieja iz bedzie on
# uzyteczny - jednak BEZ JAKIEJKOLWIEK GWARANCJI, nawet domyslnej
# gwarancji PRZYDATNOSCI HANDLOWEJ albo PRZYDATNOSCI DO OKRESLONYCH
# ZASTOSOWAN. W celu uzyskania blizszych informacji - Powszechna
# Licencja Publiczna GNU.
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
# Z pewnoscia wraz z niniejszym programem otrzymales tez egzemplarz
# Powszechnej Licencji Publicznej GNU (GNU General Public License);
# jesli nie - napisz do Free Software Foundation, Inc., 675 Mass Ave,
# Cambridge, MA 02139, USA.
# Powszechna Licencja GNU dostepna jest rowniez na stronie:
# http://www.gnu.org/licenses/licenses.html
# nieoficjalne polskie tlumaczenie na
# http://www.gnu.org.pl
# ||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

import time
import serial
import mbusbase
from   mbusbase import get16, get8, bytestr, errcode 




class mbclient(object):
	transportOpen=False
	TOUTMSG=1.0
	TOUTCHAR=2
	def __init__(self):		
		pass	


	def getReply(self):
		bstr=self.transportRead(3,self.TOUTMSG)
		if bstr != '' and bstr!=None:
			if len(bstr)<3:
				 return None 
			bajty=bytearray(bstr)
			#print bytestr(bajty)
			# find expected length
			bytescnt=0
			if bajty[1]==1 or bajty[1]==2:
				bytescnt = int(bajty[2])
			elif bajty[1]==3 or bajty[1]==4:
				bytescnt = int(bajty[2])
			elif bajty[1]==5:
				bytescnt = 4
			elif bajty[1]==5 or bajty[1]==6 or bajty[1]==15 or  bajty[1]==16:
				bytescnt = 4
			elif bajty[1]>127:
				bytescnt = 1 
			bytescnt+=2
			#print 'Expected bytes : ' + str(bytescnt)
			bstr=self.transportRead(bytescnt,self.TOUTCHAR)
			#print 'bytes : ',len(bstr)
			if bstr != '':
				if len(bstr)<bytescnt:
					 return None					 
				bajtydata=bytearray(bstr)
				#print bytestr(bajtydata)
				apdu=bajty+bajtydata
				rtu = mbusbase.receivedRtu(apdu)
				rtu.clientParse()
				return rtu
		else:
			return None
		 
	
	def transportOpen(self):
		pass

	def transportClose(self):			
		return None

	
	def transportSend(self, rawbytes):			
		return None
	
	def transportRead(self, count,timeout=None):			
		return None

	
 	#---------------------------------------------------------
 	# error resonse 
 	
 	
 	
class mbclientserial(mbclient):
	portdev=None
	def transportOpen(self, device, brate=9600, stopbit=1, timeout=0.9):
		self.mainTout=timeout
		self.charTout=12*1/brate
		self.portdev=None
		try:
			self.portdev = serial.Serial(device,  timeout = timeout, baudrate=9600, parity=serial.PARITY_EVEN, stopbits=serial.STOPBITS_ONE)
		except:
			self.portdev = None
			print "ERROR: cant open serial port: " + str(device)
			return None
		self.portdev.flushInput()
		self.portdev.setTimeout(timeout)	        
		self.portdev.baudrate=brate
                self.portdev.parity=serial.PARITY_EVEN
                self.portdev.stopbits=serial.STOPBITS_ONE
		self.transportOpen=True		


	def transportClose(self):
		try:
			self.portdev.close()
		except:
			pass
		return None

		
		
	def transportSend(self, rawbytes):
		if not self.transportOpen:
			return None
		try:
                        bb=bytearray(1)
                        for b in rawbytes:
                            bb[0]=b
                            self.portdev.write(bb)
                            time.sleep(0.005)
                        #return self.portdev.write(rawbytes)
                        return
		except:
			print "ERROR: can't write serial port "
		return None


	def transportRead(self, count,timeout):
		
		if not self.transportOpen:
			return None
		try:
			if timeout:
				if    timeout==self.TOUTMSG:  self.portdev.setTimeout(self.mainTout)
				elif  timeout==self.TOUTCHAR: self.portdev.setTimeout(self.charTout * count)   				
			return self.portdev.read(count)
		except:
			print "ERROR: can't read serial port "
		return None




if __name__ == "__main__":
	tecl = mbclientserial()
	tecl.transportOpen('/dev/ttyUSB0', brate=9600)
	#r03 = mbusbase.request01(1,0x3,20)
	r03 = mbusbase.request03(1,1,10)
	print bytestr(r03.rtu())
	tecl.transportSend(r03.rtu())
	reply=tecl.getReply()
	if reply:
		if reply.fail:
			print 'dupa' + str(reply.fail)
		else:
			print reply.vals 				 			

	#time.sleep(0.5)
	pass

